#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: nuonce_addPkg.pl,v 1.0.0.0 2006/06/07 22:00:00 bsmith Exp $
# Copyright 2006 NuOnce Networks, Inc., All rights reserved.
#

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

my (%rpms, $rpmlist);

# snarf in package list. avoid duplicates
if (open(CONF, $conf)) {
  while (<CONF>) {
    next if /^\s*#/;
    next unless /\S/;
    next if /^\S+:/;
    $rpms{"$1-$2"} = 1 if /^(\S+)\s+(\S+)/;
  }
  close(CONF);
}

$cce->connectuds();

my @oids = $cce->find('Package', {'name' => 'NUAUTHEXT' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUAUTHEXT',
                              'version' => "v2.1",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'NuOnce - Mod_Auth_Ext',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'mod_auth_external for Apache.  Includes external PAM authentication hooks',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

my @oids = $cce->find('Package', {'name' => 'NUHOSTSFIX' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUHOSTSFIX',
                              'version' => "v1.1",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'NuOnce - Hosts Fix',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'Small fix will add all IPs on your system to /etc/hosts',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

my @oids = $cce->find('Package', {'name' => 'NUMYSQLGUI' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUMYSQLGUI',
                              'version' => "v1.2",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'NuOnce - MySQL GUI',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'MySQL GUI - Change passwords, disable SQL Server and make backups',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

my @oids = $cce->find('Package', {'name' => 'NUYUMCONF' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUYUMCONF',
                              'version' => "v1.0",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'NuOnce - Yum Conf',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'Updates for software controlled by NuOnce Networks, Inc.',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

my @oids = $cce->find('Package', {'name' => 'NUCDUP' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUCDUP',
                              'version' => "v1.0",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'NuOnce - Installer Upgrade',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'Installer Updates provided via Yum',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

my @oids = $cce->find('Package', {'name' => 'NUMINDTERM' });
if ($#oids < 0) {
    $rpmlist = $cce->array_to_scalar(keys %rpms);
    $cce->create('Package', { 'name' => 'NUMINDTERM',
                              'version' => "v1.0",
                              'vendor' => 'NuOnce',
                              'nameTag' => 'Mindterm SSH Client',
                              'vendorTag' => 'NuOnce Networks',
                              'shortDesc' => 'Mindterm SSH Client',
                              'new' => 0, 'installState' => 'Installed',
                              'RPMList' => $rpmlist
                          });
    my ($sysoid) = $cce->find('System');
    $cce->set($sysoid, 'SWUpdate', { 'rpmsInstalled' => 
                                     $cce->array_to_scalar(%rpms) });
}

$cce->bye();
exit 0;
